
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Ajax跨域请求 JSON JSONP / iVAN</title>

    <meta name="description" content="Ajax跨域请求 JSON JSONP 同源策略和跨域-总结 目录: 1.同源策略 2.跨域 3.几种跨域技术   1.同源策略 什么叫同源? URL由协议.域名.端口和路径组成,如果两个URL的协议.域名和端口相同,则表示他们同源.相反,只要协议,域名,端口有任何一个的不同,就被当作是跨域. e.g. 对于http://store.company.com/dir/page.html进行同源检测: URL 结果 原因 http://store.company.com/dir2/other.html 成功 仅路径不同 http://st">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Ajax跨域请求 JSON JSONP</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1><a href="http://www.cnblogs.com/xhz-dalalala/p/5259965.html" rel="external nofollow noreferrer">同源策略和跨域-总结</a></h1>
<p>目录：</p>
<p>1.同源策略</p>
<p>2.跨域</p>
<p>3.几种跨域技术</p>
<p> </p>
<hr>
<p>1.同源策略</p>
<p>什么叫同源？</p>
<p>URL由协议、域名、端口和路径组成，如果两个URL的协议、域名和端口相同，则表示他们同源。相反，只要协议，域名，端口有任何一个的不同，就被当作是跨域。<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzYwNDk0OC8yMDE2MDMvNjA0OTQ4LTIwMTYwMzA5MjEyNjEyMDY5LTEwNzgzMjE1MzMucG5n.jpg"></p>
<p>e.g. 对于http://store.company.com/dir/page.html进行同源检测：</p>
<table>
<tbody>
<tr>
<th>
URL</th>
<th>
结果</th>
<th>
原因</th>
</tr>
<tr>
<td>
<code>http://store.company.com/dir2/other.html</code>
</td>
<td>
成功</td>
<td>
仅路径不同</td>
</tr>
<tr>
<td>
<code>http://store.company.com/dir/inner/another.html</code>
</td>
<td>
成功</td>
<td>
仅路径不同 </td>
</tr>
<tr>
<td>
<code>https://store.company.com/secure.html</code>
</td>
<td>
失败</td>
<td>
协议不同</td>
</tr>
<tr>
<td>
<code>http://store.company.com:81/dir/etc.html</code>
</td>
<td>
失败</td>
<td>
端口不同</td>
</tr>
<tr>
<td>
<code>http://news.company.com/dir/other.html</code>
</td>
<td>
失败</td>
<td>
主机名不同</td>
</tr>
</tbody>
</table>
<p> </p>
<p>同源策略  Same-Origin-Policy(SOP)</p>
<p>浏览器采用同源策略，禁止页面加载或执行与自身来源不同的域的任何脚本。换句话说浏览器禁止的是来自不同源的"document"或脚本，对当前"document"读取或设置某些属性。</p>
<p>情景：</p>
<p>比如一个恶意网站的页面通过iframe嵌入了银行的登录页面（二者不同源），如果没有同源限制，恶意网页上的javascript脚本就可以在用户登录银行的时候获取用户名和密码。</p>
<p> </p>
<p>浏览器中有哪些不受同源限制呢？</p>
<p>&lt;script&gt;、&lt;img&gt;、&lt;iframe&gt;、&lt;link&gt;这些包含 src 属性的标签可以加载跨域资源。但浏览器限制了JavaScript的权限使其不能读、写加载的内容。</p>
<p> </p>
<hr>
<p> </p>
<p>2.跨域</p>
<p>跨域是指从一个域的网页去请求另一个域的资源。比如从<a>http://www.baidu.com/</a> 页面去请求 <a>http://www.google.com</a> 的资源。</p>
<p> </p>
<hr>
<p> </p>
<p>3.跨域技术-JSONP</p>
<p>JSONP是什么？</p>
<p>上面提到过包含src属性的&lt;script&gt;标签可以加载跨域资源。 JSONP就是利用&lt;script&gt;标签的跨域能力实现跨域数据的访问。</p>
<p> </p>
<p>JSONP实现的原理</p>
<p>原文：<a href="http://www.cnblogs.com/dowinning/archive/2012/04/19/json-jsonp-jquery.html" rel="external nofollow noreferrer">说说JSON和JSONP，也许你会豁然开朗，含jQuery用例</a></p>
<p>在这之前，先来介绍下我是如何简单的开启服务的。</p>
<p>使用python的SimpleHTTPServer模块（2.x）（3.x中时http.server）The <code>SimpleHTTPServer</code> module has been merged into <code>http.server</code> in<br />
 Python 3.0.</p>
<p>------------------------------------------------------------------------------------------------</p>
<p>如果你已经用过python，请跳过这里。</p>
<p> </p>
<p>&gt;&gt;安装python（注意设置环境变量 Path -- D:\Program Files\Python2.7.1;）</p>
<p>（验证python安装配置完成：打开cmd, 输入python 有识别）</p>
<p>（cmd 切换工作目录）</p>
<p>&gt;&gt;在工作目录中执行</p>
<pre>$ python -m SimpleHTTPServer 8088 (2.x)</pre>
<pre>$ python -m http.server 8088 (3.x)</pre>
<p>&gt;&gt;服务启动后，不要关闭该窗口；否则相当于杀死了该服务进程</p>
<p> </p>
<p>------------------------------------------------我是分割线---------------------------------------</p>
<p>index.html，在8088端口提供服务</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre> 1 &lt;!doctype html&gt;
 2 &lt;html lang="en" ng-app="simpleApp"&gt;
 3 &lt;head&gt;
 4     &lt;meta charset="UTF-8"&gt;
 5     &lt;script src="scripts/vendor/angular.min.js"&gt;&lt;/script&gt;
 6     &lt;script src="scripts/vendor/angular-resource.min.js"&gt;&lt;/script&gt;
 7     &lt;script src="scripts/controllers/controllers.js"&gt;&lt;/script&gt;
 8     &lt;script src="scripts/services/services.js"&gt;&lt;/script&gt;
 9     &lt;link href="styles/bootstrap.css" rel="stylesheet"&gt;
10
11     &lt;!-- [跨域]step1. 通过拥有src属性的标签进行跨域调用 &lt;script&gt;&lt;img&gt;&lt;iframe&gt; --&gt;
12     &lt;script type="text/javascript" src="http://localhost:8090/remote.js"&gt;&lt;/script&gt;
13
14     &lt;!-- [跨域]step2. 本地函数被跨域的远程js调用，并接收远程js带来的数据 --&gt;
15     &lt;script type="text/javascript"&gt;
16         var localHandler = function(data){
17             alert('我是本地函数，可以被跨域的remote.js文件调用，远程js带来的数据是：' + data.result);
18         };
19     &lt;/script&gt;
20
21     &lt;!-- [跨域]step3. JSONP client端的核心：实现动态查询
22         怎么样让远程JS知道它应该调用的本地函数叫什么名字？
23         client传参告诉server"我想要一段调用xx函数的JS代码，请返回给我"；即client在发送请求URL时，指定回调函数--&gt;
24     &lt;script type="text/javascript"&gt;
25         // 得到航班信息查询结果后的回调函数
26         var flightHandler = function(data){
27             &lt;!-- [跨域]step4. 处理server返回的数据：几种格式 --&gt;
28             /* JSONArray
29              * flightHandler([
30              * {"code": "CA1998", "price": 1780, "tickets": 5 },
31              * {"code": "CA2001", "price": 2090, "tickets": 10 }
32              * ]);*/
33             for(var i=0; i&lt;data.length; i++){
34                 alert('你查询的航班结果是：票价 ' + data[i].price + ' 元，' + '余票 ' + data[i].tickets + ' 张。');
35             }
36
37             /* JSON
38              flightHandler({ "code": "CA1998", "price": 1780, "tickets": 5 });
39              */
40 //            alert('你查询的航班结果是：票价 ' + data.price + ' 元，' + '余票 ' + data.tickets + ' 张。');
41         };
42         // 提供jsonp服务的url地址（不管是什么类型的地址，最终生成的返回值都是一段javascript代码）
43         var url = "http://localhost:8090/remote.js?code=CA1998&amp;callback=flightHandler";
44         // 创建script标签，设置其属性
45         var script = document.createElement('script');
46         script.setAttribute('src', url);
47         // 把script标签加入head，此时调用开始
48         document.getElementsByTagName('head')[0].appendChild(script);
49     &lt;/script&gt;
50
51     &lt;title&gt;simpleApp&lt;/title&gt;
52 &lt;/head&gt;
53 &lt;body&gt;
54     &lt;div ng-view&gt;&lt;/div&gt;
55 &lt;/body&gt;
56 &lt;/html&gt;</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>remote.js，在8090端口提供服务，来模拟不同域的远程文件（端口不同）</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre> 1 alert("远程文件");
 2 localHandler({"result":"我是远程js带来的数据"});
 3
 4 //JSON
 5 flightHandler({
 6     "code": "CA1998",
 7     "price": 1780,
 8     "tickets": 5
 9 });
10
11 //JSONArray
12 flightHandler([{
13     "code": "CA1998",
14     "price": 1780,
15     "tickets": 5
16 }, {
17     "code": "CA2001",
18     "price": 2090,
19     "tickets": 10
20 }]);</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<p>JSONP的缺点</p>
<p>JSONP只支持 GET 请求。</p>
<p> </p>
<p>支持JSONP的不同技术</p>
<p>原文：<a href="http://www.thinksaas.cn/group/topic/201105/" rel="external nofollow noreferrer">详解Jquery和AngularJs中jsonp解决跨域问题</a></p>
<p>&gt;&gt;AngularJS</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>1 myUrl ="http://localhost:8090/api/test?callback=JSON_CALLBACK";
2 $http.jsonp(myUrl).success(
3      function(data){
4           alert(data);
5      }
6 );</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>1.angularJS中使用$http.jsonp函数</p>
<p>2.指定callback和回调函数名，函数名为JSON_CALLBACK时，会调用success回调函数，JSON_CALLBACK必须全为大写。</p>
<p>3.也可以指定其它回调函数，但必须是定义在window下的全局函数。</p>
<p>4.url中必须加上callback</p>
<p>5.当callback为JSON_CALLBACK时，只会调用success，即使window中有JSON_CALLBACK函数，也不会调用该函数。</p>
<p> </p>
<p>&gt;&gt;Ajax</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre> 1 myUrl ="http://localhost:8090/api/test";
 2 $.ajax({
 3   type:"GET",
 4   url:myUrl,
 5   dataType:"jsonp",
 6   jsonp:"callback",
 7   jsonpCallback:"jsonpCallback",
 8   success:function(data){
 9     alert(data.msg);
10   }
11 });
12 function jsonpCallback(data){
13      alert(data);
14 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>JSONP 是通过动态添加&lt;script&gt;标签来调用服务器的脚本（&lt;script&gt;含有src属性，src属性没有跨域限制）；而 Ajax 是通过 XHR(XmlHttpRequest) 对象。两者并没有直接关系，以上只是Ajax封装JSONP的一种方式。</p>
<p> </p>
<hr>
<p> 4.跨域技术-CORS</p>
<h2><a href="http://www.cnblogs.com/Darren_code/p/cors.html" rel="external nofollow noreferrer">AJAX POST&amp;跨域 解决方案 - CORS</a></h2>
<p> <br />
<br />
　一晃又到新年了，于是开始着手好好整理下自己的文档，顺便把一些自认为有意义的放在博客上，记录成点的点滴。</p>
<p>     <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODE5MjktMjIyMjRlMzdlM2Q1NGIwZTk1YmYyOWIwYzVkZTY5MTkuZ2lm.jpg"></p>
<p> </p>
<hr>
<p> </p>
<p>　　跨域是我在日常面试中经常会问到的问题，这词在前端界出现的频率不低，主要原因还是由于安全限制(同源策略， 即JavaScript或Cookie只能访问同域下的内容)，因为我们在日常的项目开发时会不可避免的需要进行跨域操作，所以跨域能力也算是前端工程师的基本功之一。</p>
<p>　　和大多数跨域的解决方案一样，JSONP也是我的选择，可是某天PM的需求变了，某功能需要改成支持POST，因为传输的数据量比较大，GET形式搞不定。所以折腾了下闻名已久的<strong>CORS（</strong>跨域资源共享，Cross-Origin Resource Sharing<strong>）</strong>，这边文章也就是折腾期间的小记与总结。</p>
<p>     <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODE5NTktY2E3NWM3NTYwYWZjNDJmMWE1MjA0OGJkY2FhZDQwOWEuanBn.jpg"></p>
<p>     </p>
<hr>
<p> </p>
<h1>概述</h1>

<ul>
<li>CORS能做什么：</li>
</ul>
<p>     正常使用AJAX会需要正常考虑跨域问题，所以伟大的程序员们又折腾出了一系列跨域问题的解决方案，如JSONP、flash、ifame、xhr2等等。</p>
<p>     本文介绍的CORS就是一套AJAX跨域问题的解决方案。</p>
<p> </p>
<ul>
<li> CORS的原理：</li>
</ul>
<p>     CORS定义一种跨域访问的机制，可以让AJAX实现跨域访问。CORS 允许一个域上的网络应用向另一个域提交跨域 AJAX 请求。实现此功能非常简单，只需由服务器发送一个响应标头即可。</p>
<p> </p>
<ul>
<li>CORS浏览器支持情况如下图：</li>
</ul>
<p>       <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODIwMzMtOTIzM2NlZDAwOWE2NDRmOWFmOTA5YmFjYTU3YTcyYjcucG5n.jpg"></p>
<p>     <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODIxMDMtZjQ2ZTY5N2U3MTg4NDI0MGI3MjAwZjg3MTM2OTdmYmMucG5n.jpg"></p>
<p>　　喜闻乐见、普大喜奔的支持情况，尤其是在<strong>移动终端</strong>上，除了opera Mini；</p>
<p>　　PC上的现代浏览器都能友好的支持，除了IE9-，不过前端工程师对这种情况早应该习惯了...</p>
<p>     <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODIxMzQtYjEzZTE0MTZhYTBiNDUzZjg5ZjcxYWQ5NTM4MDczNjEuanBn.jpg"></p>
<p> </p>
<h1>CORS启航</h1>
<p> </p>
<p>　　假设我们页面或者应用已在 http://www.test1.com 上了，而我们打算从 http://www.test2.com 请求提取数据。一般情况下，如果我们直接使用 AJAX 来请求将会失败，浏览器也会返回“源不匹配”的错误，"<strong>跨域</strong>"也就以此由来。</p>
<p>　　利用 CORS，http://www.test2.com 只需添加一个标头，就可以允许来自 http://www.test1.com 的请求，下图是我在PHP中的 hander() 设置，<strong>“*”号表示允许任何域向我们的服务端提交请求</strong>：</p>
<p>     <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODIxNTktYjFhMTAyYTNjZTBlNDllNzg0MWY3NjY3NTIzNmU0MDgucG5n.jpg"><br />
<br />
　　也可以设置指定的域名，如域名 http://www.test2.com ，那么就允许来自这个域名的请求：<br />
<br />
     <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODIyMjctMTBmMjJjNGY3NTA5NGZhZWI3ODI1NTUwOTE5OWFlZDUucG5n.jpg"></p>
<p>     </p>
<p>　　当前我设置的header为“*”，任意一个请求过来之后服务端我们都可以进行处理&amp;响应，那么在调试工具中可以看到其头信息设置，其中见红框中有一项信息是“<strong>Access-Control-Allow-Origin：*</strong> ”，表示我们已经启用CORS，如下图。</p>
<p>　　PS：由于demo都在我厂的两台测试机间完成，外网也不能访问，所以在这就不提供demo了，见谅<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODIzMDEtNzA2MTQ4Y2M3ZWUxNDI4OThiOGViMjVmY2Q2MmM0MDYuanBn.jpg"><br />     <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYwODIyNDItYzcwYTM3ZjIzN2VkNDhjNGE2MGQzM2ZjY2ZkNDY3ZmIucG5n.jpg"></p>
<p> 　　简单的一个header设置，一个支持跨域&amp;POST请求的server就完成了:)</p>
<p> </p>
<p>　　当然，如果没有开启CORS必定失败的啦，如下图：</p>
<p>　　<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzE1OTA5Ny8yMDE0MDEvMDYxMTA2MTEtOTUzZTE3NDc2MWU1NDVhZDk0ZGE2M2ZjZWVlOWFmYjQuanBn.jpg"></p>
<h1>问题&amp;小结</h1>
<ul>
<li>刚刚说到的兼容性。CORS是W3C中一项较新的方案，所以部分浏览器还没有对其进行支持或者完美支持，详情可移至 <a href="http://www.w3.org/TR/cors/" rel="external nofollow noreferrer">http://www.w3.org/TR/cors/</a></li>
<li>安全问题。CORS提供了一种跨域请求方案，但没有为安全访问提供足够的保障机制，如果你需要信息的绝对安全，不要依赖CORS当中的权限制度，应当使用更多其它的措施来保障，比如OAuth2。</li>
</ul>
<p> </p>
<p>　　自认为的cors使用场景：</p>
<ul>
<li>cors在移动终端支持的不错，可以考虑在移动端全面尝试；PC上有不兼容和没有完美支持，所以小心踩坑。当然浏览器兼容就是个伪命题，说不准某个浏览器的某个版本就完美兼容了，说不准就有点小坑，尼玛伤不起！～</li>
<li>jsonp是get形式，承载的信息量有限，所以信息量较大时CORS是不二选择；</li>
<li>配合新的JSAPI(fileapi、xhr2等)一起使用，实现强大的新体验功能。</li>
</ul>
<p> </p>
<p><strong>　　如果觉得这文章也算用心，请劳驾点右下角的推荐。</strong></p>
<p><strong>　　祝2014顺利。</strong></p>
<p> </p>
<p>　　最后，有 北京&amp;上海 的朋友想春节后想换工作的，【百度移动云事业部】期待聪明、勤奋的你 与我联系 (JD在页面右上角)</p>
<p> </p>
<p><strong>参考资料:</strong></p>
<p>          <a href="http://www.w3.org/TR/cors/" rel="external nofollow noreferrer">http://www.w3.org/TR/cors/</a></p>
<p>          <a href="http://www.html5rocks.com/en/tutorials/cors/" rel="external nofollow noreferrer">http://www.html5rocks.com/en/tutorials/cors/</a></p>
<p>          <a href="http://caniuse.com/#search=cors" rel="external nofollow noreferrer">http://caniuse.com/#search=cors</a></p>
<p> </p>
<h1><a href="http://blog.csdn.net/z69183787/article/details/19191385" rel="external nofollow noreferrer">JSONP原理优缺点(只能GET不支持POST)</a></h1>
<p>JSONP的优点是：它不像XMLHttpRequest对象实现的Ajax请求那样受到同源策略的限制；它的兼容性更好，在更加古老的浏览器中都 可以运行，不需要XMLHttpRequest或ActiveX的支持；并且在请求完毕后可以通过调用callback的方式回传结果。</p>
<p>JSONP的缺点则是：它只支持GET请求而不支持POST等其它类型的HTTP请求；它只支持跨域HTTP请求这种情况，不能解决不同域的两个页面之间如何进行JavaScript调用的问题。</p>
<p>===============================================================================================================</p>
<p>JSONP原理<br />
JSONP的最基本的原理是：动态添加一个&lt;script&gt;标签，而script标签的src属性是没有跨域的限制的。这样说来，这种跨域方式其实与ajax XmlHttpRequest协议无关了。</p>
<p>这样其实"jQuery AJAX跨域问题"就成了个伪命题，jquery $.ajax方法名有误导人之嫌。</p>
<p>如果设为dataType: 'jsonp'，这个$.ajax方法就和ajax XmlHttpRequest没什么关系了，取而代之的则是JSONP协议。JSONP是一个非官方的协议，它允许在服务器端集成Script tags返回至客户端，通过javascript callback的形式实现跨域访问。</p>
<p>JSONP即JSON with Padding。由于同源策略的限制，XmlHttpRequest只允许请求当前源（域名、协议、端口）的资源。如果要进行跨域请求， 我们可以通过使用html的script标记来进行跨域请求，并在响应中返回要执行的script代码，其中可以直接使用JSON传递javascript对象。 这种跨域的通讯方式称为JSONP。</p>
<p>jsonCallback 函数jsonp1236827957501(....)：是浏览器客户端注册的，获取跨域服务器上的json数据后，回调的函数</p>
<p>Jsonp的执行过程如下：</p>
<p>首先在客户端注册一个callback (如:'jsoncallback'), 然后把callback的名字(如:jsonp1236827957501)传给服务器。注意：服务端得到callback的数值后，要用jsonp1236827957501(......)把将要输出的json内容包括起来，此时，服务器生成 json 数据才能被客户端正确接收。</p>
<p>然后以 javascript 语法的方式，生成一个function， function 名字就是传递上来的参数 'jsoncallback'的值 jsonp1236827957501 .</p>
<p>最后将 json 数据直接以入参的方式，放置到 function 中，这样就生成了一段 js 语法的文档，返回给客户端。</p>
<p>客户端浏览器，解析script标签，并执行返回的 javascript 文档，此时javascript文档数据，作为参数， 传入到了客户端预先定义好的 callback 函数(如上例中jquery $.ajax()方法封装的的success: function (json))里。</p>
<p>可以说jsonp的方式原理上和&lt;script src="http://跨域/...xx.js"&gt;&lt;/script&gt;是一致的(qq空间就是大量采用这种方式来实现跨域数据交换的)。JSONP是一种脚本注入(Script Injection)行为，所以有一定的安全隐患。</p>
<p>由于Sencha Touch 2这种开发模式的特性，基本决定了它原生的数据交互行为几乎只能通过AJAX来实现。 </p>
<p>当然了，通过调用强大的PhoneGap插件然后打包，你可以实现100%的Socket通讯和本地数据库功能，又或者通过HTML5的WebSocket也可以实现与服务器的通讯和服务端推功能，但这两种方式都有其局限性，前者需要PhoneGap支持，后者要求用户设备必须支持WebSocket，因此都不能算是ST2的原生解决方案，原生的只有AJAX。 </p>
<p>  </p>
<p>说到AJAX就会不可避免的面临两个问题，第一个是AJAX以何种格式来交换数据？第二个是跨域的需求如何解决？ 这两个问题目前都有不同的解决方案，比如数据可以用自定义字符串或者用XML来描述，跨域可以通过服务器端代理来解决。 </p>
<p>但到目前为止最被推崇或者说首选的方案还是用JSON来传数据，靠JSONP来跨域。而这就是本文将要讲述的内容。 </p>
<p>  </p>
<p>JSON和JSONP虽然只有一个字母的差别，但其实他们根本不是一回事儿：JSON是一种数据交换格式，而JSONP是一种依靠开发人员的聪明才智创造出的一种非官方跨域数据交互协议。我们拿最近比较火的谍战片来打个比方，JSON是地下党们用来书写和交换情报的“暗号”，而JSONP则是把用暗号书写的情报传递给自己同志时使用的接头方式。看到没？一个是描述信息的格式，一个是信息<br />
 传递双方约定的方法。 </p>
<p>什么是JSON？ </p>
<p>前面简单说了一下，JSON是一种基于文本的数据交换方式，或者叫做数据描述格式，你是否该选用他首先肯定要关注它所拥有的优点。 </p>
<p>JSON的优点： </p>
<p>1、基于纯文本，跨平台传递极其简单； </p>
<p>2、Javascript原生支持，后台语言几乎全部支持； </p>
<p>3、轻量级数据格式，占用字符数量极少，特别适合互联网传递； </p>
<p>4、可读性较强，虽然比不上XML那么一目了然，但在合理的依次缩进之后还是很容易识别的； </p>
<p>5、容易编写和解析，当然前提是你要知道数据结构； </p>
<p>JSON的缺点当然也有，无关紧要的东西不再单独说明。 </p>
<p>JSON的格式或者叫规则： </p>
<p>JSON能够以非常简单的方式来描述数据结构，XML能做的它都能做，因此在跨平台方面两者完全不分伯仲。 </p>
<p>1、JSON只有两种数据类型描述符，大括号{}和方括号[]，其余英文冒号:是映射符，英文逗号,是分隔符，英文双引号""是定义符。 </p>
<p>2、大括号{}用来描述一组“不同类型的无序键值对集合”（每个键值对可以理解为OOP的属性描述），方括号[]用来描述一组“相同类型的有序数据集合”（可对应OOP的数组）。 </p>
<p>3、上述两种集合中若有多个子项，则通过英文逗号,进行分隔。 </p>
<p>4、键值对以英文冒号:进行分隔，并且建议键名都加上英文双引号""，以便于不同语言的解析。 </p>
<p>5、JSON内部常用数据类型无非就是字符串、数字、布尔、日期、null 这么几个，字符串必须用双引号引起来，其余的都不用，日期类型比较特殊，这里就不展开讲述了，只是建议如果客户端没有按日期排序功能需求的话，那么把日期时间直接作为字符串传递就好，可以省去很多麻烦。 </p>
<p>JSON实例： </p>
<p>Js代码 <br />// 描述一个人 <br />  <br />var person = { <br />    "Name": "Bob", <br />    "Age": 32, <br />    "Company": "IBM", <br />    "Engineer": true <br />} <br />  <br />// 获取这个人的信息 <br />  <br />var personAge = person.Age; <br />  <br />// 描述几个人 <br />  <br />var members = [ <br />    { <br />        "Name": "Bob", <br />        "Age": 32, <br />        "Company": "IBM", <br />        "Engineer": true <br />    }, <br />    { <br />        "Name": "John", <br />        "Age": 20, <br />        "Company": "Oracle", <br />        "Engineer": false <br />    }, <br />    { <br />        "Name": "Henry", <br />        "Age": 45, <br />        "Company": "Microsoft", <br />        "Engineer": false <br />    } <br />] <br />  <br />// 读取其中John的公司名称 <br />  <br />var johnsCompany = members[1].Company; <br />  <br />// 描述一次会议 <br />  <br />var conference = { <br />    "Conference": "Future Marketing", <br />    "Date": "2012-6-1", <br />    "Address": "Beijing", <br />    "Members": <br />    [ <br />        { <br />            "Name": "Bob", <br />            "Age": 32, <br />            "Company": "IBM", <br />            "Engineer": true <br />        }, <br />        { <br />            "Name": "John", <br />            "Age": 20, <br />            "Company": "Oracle", <br />            "Engineer": false <br />        }, <br />        { <br />            "Name": "Henry", <br />            "Age": 45, <br />            "Company": "Microsoft", <br />            "Engineer": false <br />        } <br />    ] <br />} <br />  <br />// 读取参会者Henry是否工程师 <br />  <br />var henryIsAnEngineer = conference.Members[2].Engineer; </p>
<p>关于JSON，就说这么多，更多细节请在开发过程中查阅资料深入学习。 </p>
<p>什么是JSONP？ </p>
<p>先说说JSONP是怎么产生的： </p>
<p>1、一个众所周知的问题，Ajax直接请求普通文件存在跨域无权限访问的问题，甭管你是静态页面、动态网页、web服务、WCF，只要是跨域请求，一律不准； </p>
<p>2、不过我们又发现，Web页面上调用js文件时则不受是否跨域的影响（不仅如此，我们还发现凡是拥有"src"这个属性的标签都拥有跨域的能力，比如&lt;script&gt;、&lt;img&gt;、&lt;iframe&gt;）； </p>
<p>3、于是可以判断，当前阶段如果想通过纯web端（ActiveX控件、服务端代理、属于未来的HTML5之Websocket等方式不算）跨域访问数据就只有一种可能，那就是在远程服务器上设法把数据装进js格式的文件里，供客户端调用和进一步处理； </p>
<p>4、恰巧我们已经知道有一种叫做JSON的纯字符数据格式可以简洁的描述复杂数据，更妙的是JSON还被js原生支持，所以在客户端几乎可以随心所欲的处理这种格式的数据； </p>
<p>5、这样子解决方案就呼之欲出了，web客户端通过与调用脚本一模一样的方式，来调用跨域服务器上动态生成的js格式文件（一般以JSON为后缀），显而易见，服务器之所以要动态生成JSON文件，目的就在于把客户端需要的数据装入进去。 </p>
<p>6、客户端在对JSON文件调用成功之后，也就获得了自己所需的数据，剩下的就是按照自己需求进行处理和展现了，这种获取远程数据的方式看起来非常像AJAX，但其实并不一样。 </p>
<p>7、为了便于客户端使用数据，逐渐形成了一种非正式传输协议，人们把它称作JSONP，该协议的一个要点就是允许用户传递一个callback参数给服务端，然后服务端返回数据时会将这个callback参数作为函数名来包裹住JSON数据，这样客户端就可以随意定制自己的函数来自动处理返回数据了。 </p>
<p>如果对于callback参数如何使用还有些模糊的话，我们后面会有具体的实例来讲解。 </p>
<p>JSONP的客户端具体实现： </p>
<p>不管jQuery也好，extjs也罢，又或者是其他支持jsonp的框架，他们幕后所做的工作都是一样的，下面我来循序渐进的说明一下jsonp在客户端的实现： </p>
<p>1、我们知道，哪怕跨域js文件中的代码（当然指符合web脚本安全策略的），web页面也是可以无条件执行的。 </p>
<p>远程服务器remoteserver.com根目录下有个remote.js文件代码如下： </p>
<p>alert('我是远程文件'); <br />本地服务器localserver.com下有个jsonp.html页面代码如下： </p>
<p>Html代码 <br />&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "<a href="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" rel="external nofollow noreferrer">http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd</a>"&gt; <br />&lt;html xmlns="<a href="http://www.w3.org/1999/xhtml" rel="external nofollow noreferrer">http://www.w3.org/1999/xhtml</a>"&gt; <br />&lt;head&gt; <br />    &lt;title&gt;&lt;/title&gt; <br />    &lt;script type="text/javascript" src="<a href="http://remoteserver.com/remote.js" rel="external nofollow noreferrer">http://remoteserver.com/remote.js</a>"&gt;&lt;/script&gt; <br />&lt;/head&gt; <br />&lt;body&gt; <br />  <br />&lt;/body&gt; <br />&lt;/html&gt; </p>
<p>毫无疑问，页面将会弹出一个提示窗体，显示跨域调用成功。 </p>
<p>2、现在我们在jsonp.html页面定义一个函数，然后在远程remote.js中传入数据进行调用。 </p>
<p>jsonp.html页面代码如下： </p>
<p>Html代码 </p>
<p>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "<a href="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" rel="external nofollow noreferrer">http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd</a>"&gt; <br />&lt;html xmlns="<a href="http://www.w3.org/1999/xhtml" rel="external nofollow noreferrer">http://www.w3.org/1999/xhtml</a>"&gt; <br />&lt;head&gt; <br />    &lt;title&gt;&lt;/title&gt; <br />    &lt;script type="text/javascript"&gt; <br />    var localHandler = function(data){ <br />        alert('我是本地函数，可以被跨域的remote.js文件调用，远程js带来的数据是：' + data.result); <br />    }; <br />    &lt;/script&gt; <br />    &lt;script type="text/javascript" src="<a href="http://remoteserver.com/remote.js" rel="external nofollow noreferrer">http://remoteserver.com/remote.js</a>"&gt;&lt;/script&gt; <br />&lt;/head&gt; <br />&lt;body&gt; </p>
<p>&lt;/body&gt; <br />&lt;/html&gt; <br />remote.js文件代码如下： </p>
<p>localHandler({"result":"我是远程js带来的数据"}); <br />运行之后查看结果，页面成功弹出提示窗口，显示本地函数被跨域的远程js调用成功，并且还接收到了远程js带来的数据。很欣喜，跨域远程获取数据的目的基本实现了，但是又一个问题出现了，我怎么让远程js知道它应该调用的本地函数叫什么名字呢？毕竟是jsonp的服务者都要面对很多服务对象，而这些服务对象各自的本地函数都不相同啊？我们接着往下看。 </p>
<p>  </p>
<p>3、聪明的开发者很容易想到，只要服务端提供的js脚本是动态生成的就行了呗，这样调用者可以传一个参数过去告诉服务端“我想要一段调用XXX函数的js代码，请你返回给我”，于是服务器就可以按照客户端的需求来生成js脚本并响应了。 </p>
<p>看jsonp.html页面的代码： </p>
<p>Html代码 <br />&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "<a href="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" rel="external nofollow noreferrer">http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd</a>"&gt; <br />&lt;html xmlns="<a href="http://www.w3.org/1999/xhtml" rel="external nofollow noreferrer">http://www.w3.org/1999/xhtml</a>"&gt; <br />&lt;head&gt; <br />    &lt;title&gt;&lt;/title&gt; <br />    &lt;script type="text/javascript"&gt; <br />    // 得到航班信息查询结果后的回调函数 <br />    var flightHandler = function(data){ <br />        alert('你查询的航班结果是：票价 ' + data.price + ' 元，' + '余票 ' + data.tickets + ' 张。'); <br />    }; <br />    // 提供jsonp服务的url地址（不管是什么类型的地址，最终生成的返回值都是一段javascript代码） <br />    var url = "<a href="http://flightquery.com/jsonp/flightResult.aspx?code=CA1998&amp;callback=flightHandler" rel="external nofollow noreferrer">http://flightQuery.com/jsonp/flightResult.aspx?code=CA1998&amp;callback=flightHandler</a>"; <br />    // 创建script标签，设置其属性 <br />    var script = document.createElement('script'); <br />    script.setAttribute('src', url); <br />    // 把script标签加入head，此时调用开始 <br />    document.getElementsByTagName('head')[0].appendChild(script); <br />    &lt;/script&gt; <br />&lt;/head&gt; <br />&lt;body&gt; <br />  <br />&lt;/body&gt; <br />&lt;/html&gt; <br /> <br />这次的代码变化比较大，不再直接把远程js文件写死，而是编码实现动态查询，而这也正是jsonp客户端实现的核心部分，本例中的重点也就在于如何完成jsonp调用的全过程。 </p>
<p>我们看到调用的url中传递了一个code参数，告诉服务器我要查的是CA1998次航班的信息，而callback参数则告诉服务器，我的本地回调函数叫做flightHandler，所以请把查询结果传入这个函数中进行调用。 </p>
<p>OK，服务器很聪明，这个叫做flightResult.aspx的页面生成了一段这样的代码提供给jsonp.html（服务端的实现这里就不演示了，与你选用的语言无关，说到底就是拼接字符串）： </p>
<p>flightHandler({ <br />    <br />"code": "CA1998", <br />    <br />"price": 1780, <br />    <br />"tickets": 5 <br />}); </p>
<p>我们看到，传递给flightHandler函数的是一个json，它描述了航班的基本信息。运行一下页面，成功弹出提示窗口，jsonp的执行全过程顺利完成！ </p>
<p>  </p>
<p>4、到这里为止的话，相信你已经能够理解jsonp的客户端实现原理了吧？剩下的就是如何把代码封装一下，以便于与用户界面交互，从而实现多次和重复调用。 </p>
<p>什么？你用的是jQuery，想知道jQuery如何实现jsonp调用？好吧，那我就好人做到底，再给你一段jQuery使用jsonp的代码（我们依然沿用上面那个航班信息查询的例子，假定返回jsonp结果不变）： </p>
<p>Html代码 </p>
<p>&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "<a href="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" rel="external nofollow noreferrer">http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd</a>"&gt; <br />&lt;html xmlns="<a href="http://www.w3.org/1999/xhtml" rel="external nofollow noreferrer">http://www.w3.org/1999/xhtml</a>"<br />
 &gt; <br />&lt;head&gt; <br />     &lt;title&gt;Untitled Page&lt;/title&gt; <br />      &lt;script type="text/javascript" src=jquery.min.js"&gt;&lt;/script&gt; <br />      &lt;script type="text/javascript"&gt; <br />     jQuery(document).ready(function(){ <br />        $.ajax({ <br />             type: "get", <br />             async: false, <br />             url: "<a href="http://flightquery.com/jsonp/flightResult.aspx?code=CA1998" rel="external nofollow noreferrer">http://flightQuery.com/jsonp/flightResult.aspx?code=CA1998</a>", <br />             dataType: "jsonp", <br />             jsonp: "callback",//传递给请求处理程序或页面的，用以获得jsonp回调函数名的参数名(一般默认为:callback) <br />             jsonpCallback:"flightHandler",//自定义的jsonp回调函数名称，默认为jQuery自动生成的随机函数名，也可以写"?"，jQuery会自动为你处理数据 <br />             success: function(json){ <br />                 alert('您查询到航班信息：票价： ' + json.price + ' 元，余票： ' + json.tickets + ' 张。'); <br />             }, <br />             error: function(){ <br />                 alert('fail'); <br />             } <br />         }); <br />     }); <br />     &lt;/script&gt; <br />     &lt;/head&gt; <br />  &lt;body&gt; <br />  &lt;/body&gt; <br />&lt;/html&gt; <br />是不是有点奇怪？为什么我这次没有写flightHandler这个函数呢？而且竟然也运行成功了！哈哈，这就是jQuery的功劳了，jquery在处理jsonp类型的ajax时（还是忍不住吐槽，虽然jquery也把jsonp归入了ajax，但其实它们真的不是一回事儿），自动帮你生成回调函数并把数据取出来供success属性方法来调用，是不是很爽呀？ </p>
<p>  <br />补充： </p>
<p>  </p>
<p>这里针对ajax与jsonp的异同再做一些补充说明： </p>
<p>1、ajax和jsonp这两种技术在调用方式上“看起来” 很像，目的也一样，都是请求一个url，然后把服务器返回的数据进行处理，因此jquery和ext等框架都把jsonp作为ajax的一种形式进行了封装； </p>
<p>2、但ajax和jsonp其实本质上是不同的东西。ajax的核心是通过XmlHttpRequest获取非本页内容，而jsonp的核心则是动态添加&lt;script&gt;标签来调用服务器提供的js脚本 。 </p>
<p>3、所以说，其实ajax与jsonp的区别不在于是否跨域，ajax通过服务端代理一样可以实现跨域，jsonp本身也不排斥同域的数据的获取。 </p>
<p>4、还有就是，jsonp是一种方式或者说非强制性协议，如同ajax一样，它也不一定非要用json格式来传递数据，如果你愿意，字符串都行，只不过这样不利于用jsonp提供公开服务。 </p>
<p>总而言之，jsonp不是ajax的一个特例，哪怕jquery等巨头把jsonp封装进了ajax，也不能改变着一点！</p>
<h1><a href="http://www.cnblogs.com/sunxucool/p/3433992.html" rel="external nofollow noreferrer">如何解决ajax跨域问题（转）</a></h1>
<p>由 于此前很少写前端的代码(哈哈，不合格的程序员啊)，最近项目中用到json作为系统间交互的手段，自然就伴随着众多ajax请求，随之而来的就是要解决 ajax的跨域问题。本篇将讲述一个小白从遇到跨域不知道是跨域问题，到知道是跨域问题不知道如何解决，再到解决跨域问题，最后找到两种方法解决ajax<br />
 跨域问题的全过程。</p>
<h4>不知是跨域问题</h4>
<p>起 因是这样的，为了复用，减少重复开发，单独开发了一个用户权限管理系统，共其他系统获取认证与授权信息，暂且称之为A系统；调用A系统以B为例。在B系统 中用ajax调用A系统系统的接口(数据格式为json)，当时特别困惑，在A系统中访问相应的url可正常回返json数据，但是在B系统中使用<br />
 ajax请求同样的url则一点儿反应都没有，好像什么都没有发生一样。这样反反复复改来改去好久都没能解决，于是求救同事，提醒可能是ajax跨域问 题，于是就将这个问题当做跨域问题来解决了。</p>
<h4>知跨域而不知如何解决</h4>
<p>知道问题的确切原因，剩下的就是找到解决问题的方法了。google了好久，再次在同事的指点下知道jQuery的ajax有jsonp这样的属性可以用来解决跨域的问题。</p>
<h4>找到一种解决方式</h4>
<p>现在也知道了怎样来解决跨域问题，余下的就是实现的细节了。实现的过程中错误还是避免不了的。由于不了解json和<a href="http://zh.wikipedia.org/wiki/JSONP" rel="external nofollow noreferrer">jsonp</a>两种格式的区别，也犯了错误，google了好久才解决。</p>
<p>首先来看看在页面中如何使用jQuery的ajax解决跨域问题的简单版：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>$(document).ready(function(){
   var url='http://localhost:8080/WorkGroupManagment/open/getGroupById"
       +"?id=1&amp;callback=?';
   $.ajax({
     url:url,
     dataType:'jsonp',
     processData: false,
     type:'get',
     success:function(data){
       alert(data.name);
     },
     error:function(XMLHttpRequest, textStatus, errorThrown) {
       alert(XMLHttpRequest.status);
       alert(XMLHttpRequest.readyState);
       alert(textStatus);
     }});
   });</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>这样写是完全没有问题的，起先error的处理函数中仅仅是alert(“error”)，为了进一步弄清楚是什么原因造成了错误，故将处理函数变 为上面的实现方式。最后一行alert使用为；parsererror。百思不得其解，继续google，最终还是在万能的stackoverflow找 到了答案，链接在<a href="http://stackoverflow.com/questions/4683114/sending-jsonp-vs-json-data" rel="external nofollow noreferrer">这里</a>。原因是jsonp的格式与json格式有着细微的差别，所以在server端的代码上稍稍有所不同。</p>
<p>比较一下json与jsonp格式的区别：</p>
<h5>json格式：</h5>

<pre>{
    "message":"获取成功",
    "state":"1",
    "result":{"name":"工作组1","id":1,"description":"11"}
}</pre>

<h5>jsonp格式：</h5>

<pre>callback({
    "message":"获取成功",
    "state":"1",
    "result":{"name":"工作组1","id":1,"description":"11"}
})</pre>
<p>看出来区别了吧，在url中callback传到后台的参数是神马callback就是神马，jsonp比json外面有多了一层，callback()。这样就知道怎么处理它了。于是修改后台代码。</p>
<p>后台java代码最终如下：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>@RequestMapping(value = "/getGroupById")
  public String getGroupById(@RequestParam("id") Long id,
      HttpServletRequest request, HttpServletResponse response)
      throws IOException {
    String callback = request.getParameter("callback");
    ReturnObject result = null;
    Group group = null;
    try {
      group = groupService.getGroupById(id);
      result = new ReturnObject(group, "获取成功", Constants.RESULT_SUCCESS);
    } catch (BusinessException e) {
      e.printStackTrace();
      result = new ReturnObject(group, "获取失败", Constants.RESULT_FAILED);
    }
    String json = JsonConverter.bean2Json(result);
    response.setContentType("text/html");
    response.setCharacterEncoding("utf-8");
    PrintWriter out = response.getWriter();
    out.print(callback + "(" + json + ")");
    return null;
  }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>注意这里需要先将查询结果转换我json格式，然后用参数callback在json外面再套一层，就变成了jsonp。指定数据类型为jsonp的ajax就可以做进一步处理了。</p>
<p>虽然这样解决了跨域问题，还是回顾下造成parsererror的原因。原因在于盲目的把json格式的数据当做jsonp格式的数据让ajax处理，造成了这个错误，此时server端代码是这样的：</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>@RequestMapping(value = "/getGroupById")
  @ResponseBody
  public ReturnObject getGroupById(@RequestParam("id") Long id,
      HttpServletRequest request, HttpServletResponse response){
    String callback = request.getParameter("callback");
    ReturnObject result = null;
    Group group = null;
    try {
      group = groupService.getGroupById(id);
      result = new ReturnObject(group, "获取成功", Constants.RESULT_SUCCESS);
    } catch (BusinessException e) {
      e.printStackTrace();
      result = new ReturnObject(group, "获取失败", Constants.RESULT_FAILED);
    }
    return result;
  }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p>至此解决ajax跨域问题的第一种方式就告一段落。</p>
<h4>追加一种解决方式</h4>
<p>追求永无止境，在google的过程中，无意中发现了一个专门用来解决跨域问题的jQuery插件-<a href="https://github.com/congmo/jquery-jsonp" rel="external nofollow noreferrer">jquery-jsonp</a>。地址：<a href="https://github.com/congmo/jquery-jsonp" rel="external nofollow noreferrer">https://github.com/congmo/jquery-jsonp</a></p>
<p>有第一种方式的基础，使用jsonp插件也就比较简单了，server端代码无需任何改动。</p>
<p>来看一下如何使用jquery-jsonp插件解决跨域问题吧。</p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>var url="http://localhost:8080/WorkGroupManagment/open/getGroupById"
    +"?id=1&amp;callback=?";
$.jsonp({
  "url": url,
  "success": function(data) {
    $("#current-group").text("当前工作组:"+data.result.name);
  },
  "error": function(d,msg) {
    alert("Could not find user "+msg);
  }
});</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<p>至此两种解决跨域问题的方式就全部介绍完毕。</p>
<p>原文地址：<a href="http://www.congmo.net/blog/2012/06/27/ajax-cross-domain/" rel="external nofollow noreferrer">http://www.congmo.net/blog/2012/06/27/ajax-cross-domain/</a></p>
<h2><a href="http://www.cnblogs.com/2050/p/3191744.html" rel="external nofollow noreferrer">js中几种实用的跨域方法原理详解</a></h2>
<p>这里说的js跨域是指通过js在不同的域之间进行数据传输或通信，比如用ajax向一个不同的域请求数据，或者通过js获取页面中不同域的框架中(iframe)的数据。只要协议、域名、端口有任何一个不同，都被当作是不同的域。</p>
<p>下表给出了相对http://store.company.com/dir/page.html同源检测的结果:</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184525-747de461b3b14f938b443e72ea25b25a.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MjYtMWNmYjA5YWE4MWM3NDJjM2JjODBlNTY0NzRlZDRlNzQucG5n.jpg"></a></p>
<p>要解决跨域的问题，我们可以使用以下几种方法：</p>
<p><strong>一、通过jsonp跨域</strong></p>
<p>在js中，我们直接用XMLHttpRequest请求不同域上的数据时，是不可以的。但是，在页面上引入不同域上的js脚本文件却是可以的，jsonp正是利用这个特性来实现的。</p>
<p>比如，有个a.html页面，它里面的代码需要利用ajax获取一个不同域上的json数据，假设这个json数据地址是<a href="http://example.com/data.php" rel="external nofollow noreferrer">http://example.com/data.php</a>,那么a.html中的代码就可以这样：</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184526-bcc1971f27094439b746cb1f52a715be.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MjctNGE4ZDZkYWYxZGUyNDQ3OGJkNDkyNDQxNzU1ZWU1ZDQucG5n.jpg"></a></p>
<p>我们看到获取数据的地址后面还有一个callback参数，按惯例是用这个参数名，但是你用其他的也一样。当然如果获取数据的jsonp地址页面不是你自己能控制的，就得按照提供数据的那一方的规定格式来操作了。</p>
<p>因为是当做一个js文件来引入的，所以<a href="http://example.com/data.php" rel="external nofollow noreferrer">http://example.com/data.php</a>返回的必须是一个能执行的js文件，所以这个页面的php代码可能是这样的:</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184527-28a9558c3caa424683980a50b8371134.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MjgtNWJjMDFjN2ZiNTdjNDc0Y2E2ZmFmYTZlZGQwOTIxOGQucG5n.jpg"></a></p>
<p>最终那个页面输出的结果是:</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184528-32bbea18197b4e35bb5f67480da1f367.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MjktNTc3NjBjODcxMWE1NGZkZTk4MzliNTkzNGQ4YmRkZDAucG5n.jpg"></a></p>
<p>所以通过<a href="http://example.com/data.php?callback=dosomething" rel="external nofollow noreferrer">http://example.com/data.php?callback=dosomething</a>得到的js文件，就是我们之前定义的dosomething函数,并且它的参数就是我们需要的json数据，这样我们就跨域获得了我们需要的数据。</p>
<p>这样jsonp的原理就很清楚了，通过script标签引入一个js文件，这个js文件载入成功后会执行我们在url参数中指定的函数，并且会把我们需要的json数据作为参数传入。所以jsonp是需要服务器端的页面进行相应的配合的。</p>
<p>知道jsonp跨域的原理后我们就可以用js动态生成script标签来进行跨域操作了，而不用特意的手动的书写那些script标签。如果你的页面使用jquery，那么通过它封装的方法就能很方便的来进行jsonp操作了。</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184529-f4a5efe2881a40eebbdca2b463e264bf.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzAtMTA3MmVmNDNjNjFiNGYxNjllYWFiZDJkZmRmZGU3ZWYucG5n.jpg"></a></p>
<p>原理是一样的，只不过我们不需要手动的插入script标签以及定义回掉函数。jquery会自动生成一个全局函数来替换callback=?中的问号，之后获取到数据后又会自动销毁，实际上就是起一个临时代理函数的作用。$.getJSON方法会自动判断是否跨域，不跨域的话，就调用普通的ajax方法；跨域的话，则会以异步加载js文件的形式来调用jsonp的回调函数。</p>
<p> </p>
<p><strong>2、通过修改document.domain来跨子域</strong></p>
<p>浏览器都有一个同源策略，其限制之一就是第一种方法中我们说的不能通过ajax的方法去请求不同源中的文档。 它的第二个限制是浏览器中不同域的框架之间是不能进行js的交互操作的。有一点需要说明，不同的框架之间（父子或同辈），是能够获取到彼此的window对象的，但蛋疼的是你却不能使用获取到的window对象的属性和方法(html5中的postMessage方法是一个例外，还有些浏览器比如ie6也可以使用top、parent等少数几个属性)，总之，你可以当做是只能获取到一个几乎无用的window对象。比如，有一个页面，它的地址是<a href="http://www.example.com/a.html" rel="external nofollow noreferrer">http://www.example.com/a.html</a> <br />
 ， 在这个页面里面有一个iframe，它的src是<a href="http://example.com/b.html" rel="external nofollow noreferrer">http://example.com/b.html</a>, 很显然，这个页面与它里面的iframe框架是不同域的，所以我们是无法通过在页面中书写js代码来获取iframe中的东西的：</p>
<p>  <a href="http://images.cnitblog.com/blog/130623/201307/15184530-8b5ff5011fc24c7a9949eac174a4dc73.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzEtM2JjMDRhYTQ0MmQ5NDk0YmFlOGRjMWYzMjU1MTM4OTMucG5n.jpg"></a></p>
<p>这个时候，document.domain就可以派上用场了，我们只要把<a href="http://www.example.com/a.html" rel="external nofollow noreferrer">http://www.example.com/a.html</a> 和 <a href="http://example.com/b.html" rel="external nofollow noreferrer">http://example.com/b.html</a>这两个页面的document.domain都设成相同的域名就可以了。但要注意的是，document.domain的设置是有限制的，我们只能把document.domain设置成自身或更高一级的父域，且主域必须相同。例如：a.b.example.com<br />
 中某个文档的document.domain 可以设成a.b.example.com、b.example.com 、example.com中的任意一个，但是不可以设成 c.a.b.example.com,因为这是当前域的子域，也不可以设成baidu.com,因为主域已经不相同了。</p>
<p>在页面 <a href="http://www.example.com/a.html" rel="external nofollow noreferrer">http://www.example.com/a.html</a> 中设置document.domain:</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184531-49f512a730204cab803ce03833e4b554.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzItYWQ5ODA4MmVlNTA0NDkyMWIxYjY2N2YxZWMyYjgyMmIucG5n.jpg"></a></p>
<p>在页面 <a href="http://example.com/b.html" rel="external nofollow noreferrer">http://example.com/b.html</a> 中也设置document.domain，而且这也是必须的，虽然这个文档的domain就是example.com,但是还是必须显示的设置document.domain的值：</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184533-f10eef95c6994d09bc2d595325f45759.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzMtYWFhMzdkMWE0NDZmNGZmMjg3MWQ5ZTJiM2U5NDc3ZGEucG5n.jpg"></a></p>
<p>这样我们就可以通过js访问到iframe中的各种属性和对象了。</p>
<p>不过如果你想在<a href="http://www.example.com/a.html" rel="external nofollow noreferrer">http://www.example.com/a.html</a> 页面中通过ajax直接请求<a href="http://example.com/b.html" rel="external nofollow noreferrer">http://example.com/b.html</a> 页面，即使你设置了相同的document.domain也还是不行的，所以修改document.domain的方法只适用于不同子域的框架间的交互。如果你想通过ajax的方法去与不同子域的页面交互，除了使用jsonp的方法外，还可以用一个隐藏的iframe来做一个代理。原理就是让这个iframe载入一个与你想要通过ajax获取数据的目标页面处在相同的域的页面，所以这个iframe中的页面是可以正常使用ajax去获取你要的数据的，然后就是通过我们刚刚讲得修改document.domain的方法，让我们能通过js完全控制这个iframe，这样我们就可以让iframe去发送ajax请求，然后收到的数据我们也可以获得了。</p>
<p> </p>
<p><strong>3、使用window.name来进行跨域</strong></p>
<p>window对象有个name属性，该属性有个特征：即在一个窗口(window)的生命周期内,窗口载入的所有的页面都是共享一个window.name的，每个页面对window.name都有读写的权限，window.name是持久存在一个窗口载入过的所有页面中的，并不会因新页面的载入而进行重置。</p>
<p>比如：有一个页面a.html,它里面有这样的代码：</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184534-769ff1574c304d11accd26cbbbd1f9da.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzQtZWJiZTM2NTIzMTUxNDE5Y2IyMGRmN2JlYjM3YzI3N2EucG5n.jpg"></a></p>
<p>再看看b.html页面的代码：</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184535-fd6a9a0604754241a8f8947ced97b8e9.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzUtYjZjMGJjMmUzN2RmNDBmMWFlM2IxMTNhMDhlOWVkYjQucG5n.jpg"></a></p>
<p>a.html页面载入后3秒，跳转到了b.html页面，结果为：</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184536-5eadbc78e1fc4c8bb573aefa486ca52c.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzctMjZhYjkyZWM4Y2RjNDQ0ZjhiOWZhNmZjNjJlZDc4ZmIucG5n.jpg"></a></p>
<p>我们看到在b.html页面上成功获取到了它的上一个页面a.html给window.name设置的值。如果在之后所有载入的页面都没对window.name进行修改的话，那么所有这些页面获取到的window.name的值都是a.html页面设置的那个值。当然，如果有需要，其中的任何一个页面都可以对window.name的值进行修改。注意，window.name的值只能是字符串的形式，这个字符串的大小最大能允许2M左右甚至更大的一个容量，具体取决于不同的浏览器，但一般是够用了。</p>
<p>上面的例子中，我们用到的页面a.html和b.html是处于同一个域的，但是即使a.html与b.html处于不同的域中，上述结论同样是适用的，这也正是利用window.name进行跨域的原理。</p>
<p>下面就来看一看具体是怎么样通过window.name来跨域获取数据的。还是举例说明。</p>
<p>比如有一个<a href="http://www.example.com/a.html" rel="external nofollow noreferrer">www.example.com/a.html</a>页面,需要通过a.html页面里的js来获取另一个位于不同域上的页面<a href="http://www.cnblogs.com/data.html" rel="external nofollow noreferrer">www.cnblogs.com/data.html</a>里的数据。</p>
<p>data.html页面里的代码很简单，就是给当前的window.name设置一个a.html页面想要得到的数据值。data.html里的代码：</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184538-f329d65db57d49c3b89bef6d413e34ad.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1MzktN2ExOTBhMmViOWQ1NDY0Nzg3YTEyNGY1ZTJjNmEwNmQucG5n.jpg"></a></p>
<p>那么在a.html页面中，我们怎么把data.html页面载入进来呢？显然我们不能直接在a.html页面中通过改变window.location来载入data.html页面，因为我们想要即使a.html页面不跳转也能得到data.html里的数据。答案就是在a.html页面中使用一个隐藏的iframe来充当一个中间人角色，由iframe去获取data.html的数据，然后a.html再去得到iframe获取到的数据。</p>
<p>充当中间人的iframe想要获取到data.html的通过window.name设置的数据，只需要把这个iframe的src设为<a href="http://www.cnblogs.com/data.html" rel="external nofollow noreferrer">www.cnblogs.com/data.html</a>就行了。然后a.html想要得到iframe所获取到的数据，也就是想要得到iframe的window.name的值，还必须把这个iframe的src设成跟a.html页面同一个域才行，不然根据前面讲的同源策略，a.html是不能访问到iframe里的window.name属性的。这就是整个跨域过程。</p>
<p>看下a.html页面的代码：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEzMDYyMy8yMDE1MTIvMTMwNjIzLTIwMTUxMjA3MTYxMDIyNjUyLTIxMTg2MjI2NTQucG5n.jpg"></p>
<p>上面的代码只是最简单的原理演示代码，你可以对使用js封装上面的过程，比如动态的创建iframe,动态的注册各种事件等等，当然为了安全，获取完数据后，还可以销毁作为代理的iframe。网上也有很多类似的现成代码，有兴趣的可以去找一下。</p>
<p>通过window.name来进行跨域，就是这样子的。</p>
<p> </p>
<p><strong>4、使用HTML5中新引进的window.postMessage方法来跨域传送数据</strong></p>
<p>window.postMessage(message,targetOrigin)  方法是html5新引进的特性，可以使用它来向其它的window对象发送消息，无论这个window对象是属于同源或不同源，目前IE8+、FireFox、Chrome、Opera等浏览器都已经支持window.postMessage方法。</p>
<p>调用postMessage方法的window对象是指要接收消息的那一个window对象，该方法的第一个参数message为要发送的消息，类型只能为字符串；第二个参数targetOrigin用来限定接收消息的那个window对象所在的域，如果不想限定域，可以使用通配符 *  。</p>
<p>需要接收消息的window对象，可是通过监听自身的message事件来获取传过来的消息，消息内容储存在该事件对象的data属性中。</p>
<p>上面所说的向其他window对象发送消息，其实就是指一个页面有几个框架的那种情况，因为每一个框架都有一个window对象。在讨论第二种方法的时候，我们说过，不同域的框架间是可以获取到对方的window对象的，而且也可以使用window.postMessage这个方法。下面看一个简单的示例，有两个页面</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184544-594f30a8bacd4da0a4a2293f63f53534.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1NDUtNGQ0MzUyODZkOTk3NGM2NTg5MGVjZWNiY2U4YmU5YjcucG5n.jpg"></a></p>
<p> </p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184545-4285b632b74c4abea9aba5ecb2587f5a.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1NDYtNmQ1NGFkYTI2YjFhNDdjYzhkODU2YjBjZDkwZDYwMTcucG5n.jpg"></a></p>
<p>我们运行a页面后得到的结果:</p>
<p><a href="http://images.cnitblog.com/blog/130623/201307/15184547-b7a7e7b771054807b112248f39201e53.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzEzMDYyMy8yMDEzMDcvMTUxODQ1NDctYzNjMzMxN2IzYTY3NGI5YzhiZmI2NWIxODk4ZTE4MjkucG5n.jpg"></a></p>
<p>我们看到b页面成功的收到了消息。</p>
<p>使用postMessage来跨域传送数据还是比较直观和方便的，但是缺点是IE6、IE7不支持，所以用不用还得根据实际需要来决定。</p>
<p> </p>
<p><strong>结语：</strong></p>
<p>除了以上几种方法外，还有flash、在服务器上设置代理页面等跨域方式，这里就不做介绍了。</p>
<p>以上四种方法，可以根据项目的实际情况来进行选择应用，个人认为window.name的方法既不复杂，也能兼容到几乎所有浏览器，这真是极好的一种跨域方法。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 12:00:18</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Ajax跨域请求 JSON JSONP的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmGWA7b.html" rel="bookmark">AJAX跨域请求之JSONP获取JSON数据&lowbar;AJAX相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Asynchronous JavaScript and XML (Ajax ) 是驱动新一代 Web 站点(流行术语为 Web 2.0 站点)的关键技术.Ajax 允许在不干扰 Web 应用程序的显示和行为的情况下在后台进行数据检索.使用 XMLHttpRequest 函数获取数据,它是一种 API,允许客户端 JavaScript 通过 HTTP 连接到远程服务器.Ajax 也是许多 mashup 的驱动力,它可将来自多个地方的内容集成为单一 Web 应用程序. 不过,由于受到浏览器的限制,该			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqaXJZM.html" rel="bookmark">AJAX跨域请求之JSONP获取JSON数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Asynchronous JavaScript and XML (Ajax ) 是驱动新一代 Web 站点(流行术语为 Web 2.0 站点)的关键技术.Ajax 允许在不干扰 Web 应用程序的显示和行为的情况下在后台进行数据检索.使用 XMLHttpRequest 函数获取数据,它是一种 API,允许客户端 JavaScript 通过 HTTP 连接到远程服务器.Ajax 也是许多 mashup 的驱动力,它可将来自多个地方的内容集成为单一 Web 应用程序. 不过,由于受到浏览器的限制,该			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJOoDqb.html" rel="bookmark">AJAX跨域请求json数据的实现方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们都知道,AJAX的一大限制是不允许跨域请求. 不过通过使用JSONP来实现.JSONP是一种通过脚本标记注入的方式,它是可以引用跨域URL的js脚本,不过需要提供一个回调函数(必须在您自己的页面上),因此,你可以自己处理结果. 让我们看看JSONP的是怎么在jQuery,MooTools的,Dojo Toolkit中实现的. jQuery的JSONPjQuery.getJSON方法: Js代码 复制代码 代码如下: jQuery.getJSON(&quot;http://search.twitter.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDy3mvb.html" rel="bookmark">AJAX跨域请求JSONP获取JSON数据的实例代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Asynchronous JavaScript and XML (Ajax) 是驱动新一代 Web 站点(流行术语为 Web 2.0 站点)的关键技术.Ajax 允许在不干扰 Web 应用程序的显示和行为的情况下在后台进行数据检索.使用XMLHttpRequest 函数获取数据,它是一种 API,允许客户端 JavaScript 通过 HTTP 连接到远程服务器.Ajax 也是许多 mashup 的驱动力,它可将来自多个地方的内容集成为单一 Web 应用程序. 不过,由于受到浏览器的限制,该方法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPXVmp.html" rel="bookmark">ajax跨域请求学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:ajax跨域请求学习笔记 前言 ajax,用苍白的话赞扬:很好. 我们可以使用ajax实现异步获取数据,减少服务器运算时间,大大地改善用户体验:我们可以使用ajax实现小系统组合大系统:我们还可以使用ajax实现前端的优化.(好一个排比) 虽然ajax很好,但在使用起来也会有一定的限制,出于安全考虑,不允许跨域通信.如果尝试从不同的域请求数据,会出现安全错误.(下面例子1可以直观看出) 同源策略限制 同源策略阻止从一个域上加载的脚本获取或操作另一个域上的文档属性.也就是说,受到请求的 UR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBerwM.html" rel="bookmark">如果要用ajax跨域请求服务器数据&comma;服务器是否要设置支持跨域</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如果要用ajax跨域请求服务器数据,服务器是否要设置支持跨域 如果要用ajax跨域请求服务器数据,服务器是否要设置支持跨域? 解决方案 是的,如果是跨域请求的话,服务器返回Json数据的格式也是不同的. 所以服务器也是需要支持跨域的. 如:服务器返回普通Json格式为(不跨域) { &quot;code&quot;: &quot;0&quot;, &quot;content&quot;: &quot;我是返回内容&quot; } 那么Jsonp的返回格式则是(跨域) callback({ &qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkALez.html" rel="bookmark">jQuery使用ajax跨域请求获取数据&lowbar;AJAX相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				跨域是我在日常面试中经常会问到的问题,这词在前端界出现的频率不低,主要原因还是由于安全限制(同源策略, 即JavaScript或Cookie只能访问同域下的内容),因为我们在日常的项目开发时会不可避免的需要进行跨域操作,所以跨域能力也算是前端工程师的基本功之一. var webMethod = &quot;http://localhost:54473/Service1.asmx/HelloWorld&quot;; jQuery.support.cors = true; //之前没有加这句老是提示no tr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZAokz.html" rel="bookmark">JQuery的Ajax跨域请求原理概述及实例&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在项目中需要做远程数据加载并渲染页面,直到开发阶段才意识到ajax跨域请求的问题,隐约记得Jquery有提过一个ajax跨域请求的解决方式,于是即刻翻出Jquery的API出来研究,发 JQuery对于Ajax的跨域请求有两类解决方案,不过都是只支持get方式.分别是JQuery的 jquery.ajax jsonp格式和jquery.getScript方式. 什么是jsonp格式呢?API原文:如果获取的数据文件存放在远程服务器上(域名不同,也就是跨域获取数据),则需要使用jsonp类型.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba6kdQM.html" rel="bookmark">jquery的ajax跨域请求原理和示例&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天在项目中需要做远程数据加载并渲染页面,直到开发阶段才意识到ajax跨域请求的问题,隐约记得Jquery有提过一个ajax跨域请求的解决方式,于是即刻翻出Jquery的API出来研究,发 JQuery对于Ajax的跨域请求有两类解决方案,不过都是只支持get方式.分别是JQuery的 jquery.ajax jsonp格式和jquery.getScript方式. 什么是jsonp格式呢?API原文:如果获取的数据文件存放在远程服务器上(域名不同,也就是跨域获取数据),则需要使用jsonp类型.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBkOaM.html" rel="bookmark" class="title">【转载】据说是python常用的模块</a>
					<div>
						difflib python diff比较模块 datetime python 处理日期与时间的模块 chardet 字符串/文件 编码检测(很好用) adodb:我们领导推荐的数据库连接组件 bsd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLPBap.html" rel="bookmark" class="title">周鸿袆终受网络正义的审判</a>
					<div>
						法律的天平终将向正义方倾斜,奇虎的连续败诉意味着,以裹胁民意.肆意诋毁他人名誉.牟取经济利益为特征的网络邪教,再次遭到正义的审判. 自去年以来,奇虎这个以社区搜索.社区联盟为主营业务的企业.为了达到出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6jDgM.html" rel="bookmark" class="title">Flash鼠绘小男孩（菜鸟极作品）</a>
					<div>
						1.首先选择直线工具勾个大概的轮廓. 2.然后用选择工具调整线条 3.新建一层用直线工具画出头发的大体样子,同样用选择工具调整线条 4.接下来,新建两层分别画耳朵和后面的头发,然后调整线条  新建一层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBOgOM.html" rel="bookmark" class="title">用户体验&colon;用户体验的进化</a>
					<div>
						之前很长一段时间,我都发现.用户体验专业人员还在不停的向人们解释什么是用户体验,用户体验有多重要等等常规问题.当然,这是用户体验在中国的现状造成的,用户体验从业者自己也需要接触.学习更多的知识和技能, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPkwoz.html" rel="bookmark" class="title">MySQL中使用ALTER TABLE的问题</a>
					<div>
						ALTER TABLE将表更改为当前字符集.如果在执行ALTER TABLE操作期间遇到重复键错误,原因在于新的字符集将2个键映射到了相同值,或是表已损坏.在后一种情况下,应在表上运行REPAIR T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91AKRM.html" rel="bookmark" class="title">教你一招让你的Windows XP加速</a>
					<div>
						Microsoft Windows XP操作系统一经推出,就以美观的交互界面打动了广大计算机用户,再加上优异的总体性能(包括显著缩短了启动和继续使用的时间,以及应用程序的快速响应),使得很多用户纷纷将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP6KBM.html" rel="bookmark" class="title">在C&plus;&plus; Builder中取得命令行参数</a>
					<div>
						用过C语言编程的人都知道,在DOS下的编程可以通过main函数的参数取得命令行参数的个数以及每个参数的字符串,例如 int main(int argv ,char *argv[]) { - } 则命令 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwjj9z.html" rel="bookmark" class="title">&lbrack;JAVA100例&rsqb;068、使用DOM解析XML</a>
					<div>
						import javax.xml.parsers.*; import org.w3c.dom.*; import java.io.*; public class DOMPageList { publi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKj3mp.html" rel="bookmark" class="title">移动设备手势设计初探</a>
					<div>
						嘿~最近在做各种移动端的产品,设计啊体验啊操作啊,用的手都起茧,工作之余也思考了&quot;手&quot;这种较新的交互方式,以及它与界面的关系.本文从手势的种类,应用场景,存在的可用性问题以及如何设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8Qmab.html" rel="bookmark" class="title">php smarty模版引擎中的缓存应用&lowbar;php技巧</a>
					<div>
						1,Smarty缓存的配置: 复制代码 代码如下: $smarty-&gt;cache-dir=&quot;目录名&quot;; //创建缓存目录名 $smarty-&gt;caching=true; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7rqez.html" rel="bookmark" class="title">asp封闭成dll文件</a>
					<div>
						ASP 文件做成DLL文件 当创建或使用复杂的ASP Web应用你一定会碰到一个需要使用的DLL .该DLL通常包括代码,汇编在VB , C + +中,或者其他Windows编程语言,用于ASP应用程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7QK3z.html" rel="bookmark" class="title">动态规划 扑克-利用动态规划解决n张扑克连接问题</a>
					<div>
						问题描述 利用动态规划解决n张扑克连接问题 有n卡扑克,分别有A B C D四种花色,扑克面值为 0~9,花色相同或者面值相同的两张扑克可以进行连接,其中,面值为8的扑克可以与任意的扑克进行连接.问怎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAA2d3M.html" rel="bookmark" class="title">Adobe遭创业公司起诉 PhotoShop或涉嫌剽窃</a>
					<div>
						北京时间9月22日凌晨消息,据国外媒体报道,美国一家名为EveryScape的创业公司起诉Adobe,称其将该公司创始人Byong Mok Oh开发的一款插件用于Photoshop,并将该技术据为己有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgREO3b.html" rel="bookmark" class="title">《21天学通C语言（第7版）》一6&period;2 控制程序的执行</a>
					<div>
						6.2 控制程序的执行 21天学通C语言(第7版) C程序默认的执行顺序是自上而下.从main()函数的起始位置开始,逐条执行语句,直至main()函数的末尾.然而,在实际的C程序中,很少严格按这样的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLNBnp.html" rel="bookmark" class="title">magento 1&period;4 -- 后台分类页和产品页字段名无法翻译的bug及解决方案</a>
					<div>
						在将1.3用的语言包放到1.4上使用之后,发现后台后台分类页和产品页字段都是英文,而这些英文词在Mage_Catalog.csv中翻译都存在,却不起作用了.是1.4用新的语言包文件来翻译这些词了吗?在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKjorz.html" rel="bookmark" class="title">ThinkPHP和UCenter接口冲突的解决方法&lowbar;php实例</a>
					<div>
						本文分析了ThinkPHP和UCenter接口冲突的解决方法.分享给大家供大家参考,具体如下: 1.引出问题: 在UCenter中存在db和base两个类,恰巧这两个类也存在于ThinkPHP中,因此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rZJrp.html" rel="bookmark" class="title">请教什么波形控件可以支持画10万个以上的点？</a>
					<div>
						问题描述 我做的是个远程监控系统,大约一天的数据量大概在12万条左右,现要画曲线图显示1天的数据变化情况,可是10万条实在太多了,我用ConponentOne的C1Chart画,几乎就成一坨了,而且速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7eBkM.html" rel="bookmark" class="title">华为荣耀3C</a>
					<div>
						电眼靓丽小甜心礼服秀 展示华为荣耀3C 类型:转载 作者:王子砚 时间:2014-05-01 05:30:00 第1页: 荣耀3C配置是5英寸720P高清全贴合黑瀑布屏.TD-SCDMA/GSM 和W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RnE7z.html" rel="bookmark" class="title">android异步图片加载三之handler&plus;线程池&plus;消息队列模式&plus;缓存</a>
					<div>
						http://blog.csdn.net/soesa/article/details/7787922 假象现在有这样一个需求:       一个微博客户端或者多媒体客户端需要从服务端拉取一些数据,该数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodrajM.html" rel="bookmark" class="title">暴雪中国总经理、发行副总裁戴锦和决定离开暴雪</a>
					<div>
						网易科技讯 7月21日消息,暴雪娱乐今日宣布,暴雪http://www.aliyun.com/zixun/aggregation/1459.html&quot;&gt;中国总经理.发行副总裁戴锦和决定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWWg5z.html" rel="bookmark" class="title">Access保留字&amp;amp&semi;amp&semi;变量名列表&lowbar;Access</a>
					<div>
						Access保留字&amp;变量名列表,建表时应避免使用这些词汇和符号. Access 2002/2003 - 复制代码 代码如下: A      ADD      ALL      Alphanum ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7mXrM.html" rel="bookmark" class="title">Android中关于JSON相关应用分析&lowbar;Android</a>
					<div>
						本文分析了Android中关于JSON相关应用.分享给大家供大家参考,具体如下: JSON的定义: 一种轻量级的数据交换格式,具有良好的可读和便于快速编写的特性.业内主流技术为其提供了完整的解决方案( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmKlNz.html" rel="bookmark" class="title">ASP&period;NET&lpar;AJAX&plus;JSON&rpar;实现对象调用&lowbar;实用技巧</a>
					<div>
						客户端: 复制代码 代码如下: &lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeFile=&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GKNWp.html" rel="bookmark" class="title">怎样动态绑定下拉列表框&lpar;在线等待&rpar;</a>
					<div>
						问题描述 我有个&quot;联系人分组表&quot;,其中有&quot;同事&quot;,&quot;朋友&quot;...等等,我在操作时,需要添加一个组&quot;家人&quot;,而在&lt;s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZQ6Qb.html" rel="bookmark" class="title">高通三款处理器齐发布 全面死磕联发科</a>
					<div>
						在去年的智能手机处理器之战中,华为麒麟950就像一匹黑马在性能上不输骁龙810.三星Exynos 7420.联发科Helio X10,取得了非常不错的表现,而搭载麒麟950处理器的Mate 8更是成为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvY2Krb.html" rel="bookmark" class="title">百度用的什么操作系统</a>
					<div>
						问题描述 百度用的什么操作系统 上网站查询发现百度web服务器是bws,操作系统是unknown,那么问题来了,百度到底用的是什么操作系统 解决方案 能做服务器的操作系统就这么几个,我不相信 BAID ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEqOjp.html" rel="bookmark" class="title">zedgraph蜡烛曲线类似股票的红绿色如何设置</a>
					<div>
						问题描述 GraphPanemyPane=base.GraphPane;myPane.Title.Text=&quot;UER/USD(欧/日)&quot;;myPane.XAxis.Title.Te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmV5rBz.html" rel="bookmark" class="title">想在项目中实现上传的文件在线预览功能，请问用什么技术好</a>
					<div>
						问题描述 目前是用的FlexPaper结合pdf2swf和openoffice实现的,感觉比较繁琐,需要在服务器上先安装openoffice程序,word转换为pdf时占用内存,利用FlexPaper ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBy6eNz.html" rel="bookmark" class="title">摩洛哥双网运营商WANA推出GSM业务</a>
					<div>
						C114讯 北京时间2月23日凌晨消息(蒋均牧)自2009年2月获得GSM牌照后经过近一年筹备,摩洛哥第三大移动运营商WANA宣布已推出名为&quot;Inwi&quot;的GSM业务.WANA方面表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2QLOz.html" rel="bookmark" class="title">问个SWING的问题。每次弹出新窗口都要用监听器吗？</a>
					<div>
						问题描述 我遇到的问题是,我写的是记事本退出提醒保存的功能.保存功能savefile.java的类我已经写好.我给加了监听器button.addactionlistener(newquitapp()) ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.125 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
